package main

import (
	"context"
	"log"
	"os"
	"os/signal"
	"sync"
	"syscall"
)

type message struct {
	Author int
	ID     int
}

func main() {
	ch := make(chan message, 2)

	ctx, cancel := context.WithCancel(context.Background())

	wg := &sync.WaitGroup{}
	for i := 0; i < 2; i++ {
		wg.Add(1)
		go producer(ctx, ch, wg, i)
	}

	for i := 0; i < 2; i++ {
		wg.Add(1)
		go consumer(ctx, ch, wg, i)
	}

	termChan := make(chan os.Signal)
	signal.Notify(termChan, syscall.SIGINT, syscall.SIGTERM)
	<-termChan // počkáme než na tomhle kanálu něco přijde

	signal.Stop(termChan) // po tomhle už Ctrl-C už nechytáme

	log.Printf("🚫 RECEIVED STOP SIGNAL -> cancelling context")
	cancel()

	log.Printf("🚫 Waiting for all workers to stop")
	wg.Wait()
}
