package main

import (
	"context"
	"log"
	"sync"
	"time"
)

func producer(ctx context.Context, ch chan<- message, wg *sync.WaitGroup, ID int) {
	defer wg.Done()

	ticker := time.NewTicker(time.Second * 1)
	messageID := 1
	for range ticker.C {
		select {
		case <-ctx.Done():
			log.Printf("[🏭 Producer %d] Ending", ID)
			return
		case ch <- message{Author: ID, ID: messageID}:
			log.Printf("[🏭 Producer %d] Sended message ID %d", ID, messageID)
			messageID++
		}
	}
}
