package geom

import "math"

type Shape interface {
	Area() float64
	Perimeter() float64
}

type Rectangle struct {
	LeftTop     Point
	RightBottom Point
}

func (r Rectangle) width() float64  { return r.RightBottom.X - r.LeftTop.X }
func (r Rectangle) height() float64 { return r.RightBottom.Y - r.LeftTop.Y }
func (r Rectangle) Area() float64 {
	return r.width() * r.height()
}
func (r Rectangle) Perimeter() float64 {
	return 2 * (r.width() + r.height())
}

type Circle struct {
	Center Point
	Radius float64
}

func (c Circle) Area() float64 {
	return math.Pi * c.Radius * c.Radius
}
func (c Circle) Perimeter() float64 {
	return 2 * math.Pi * c.Radius
}
